<?php
namespace Mirasvit\SearchAutocomplete\Controller\Ajax\Suggest;

/**
 * Interceptor class for @see \Mirasvit\SearchAutocomplete\Controller\Ajax\Suggest
 */
class Interceptor extends \Mirasvit\SearchAutocomplete\Controller\Ajax\Suggest implements \Magento\Framework\Interception\InterceptorInterface
{
    use \Magento\Framework\Interception\Interceptor;

    public function __construct(\Mirasvit\SearchAutocomplete\Model\Result $result, \Magento\Framework\View\LayoutInterface $layout, \Magento\Framework\Serialize\Serializer\Json $serializer, \Magento\Framework\App\Action\Context $context)
    {
        $this->___init();
        parent::__construct($result, $layout, $serializer, $context);
    }

    /**
     * {@inheritdoc}
     */
    public function execute()
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'execute');
        return $pluginInfo ? $this->___callPlugins('execute', func_get_args(), $pluginInfo) : parent::execute();
    }

    /**
     * {@inheritdoc}
     */
    public function dispatch(\Magento\Framework\App\RequestInterface $request)
    {
        $pluginInfo = $this->pluginList->getNext($this->subjectType, 'dispatch');
        return $pluginInfo ? $this->___callPlugins('dispatch', func_get_args(), $pluginInfo) : parent::dispatch($request);
    }
}
